Index: channels/chan_sip.c
===================================================================
--- channels/chan_sip.c	(revision 92441)
+++ channels/chan_sip.c	(working copy)
@@ -3878,9 +3878,11 @@
 		res = -1;
 		break;
 	case AST_CONTROL_HOLD:
+		ast_rtp_reset(p->rtp);
 		ast_moh_start(ast, data, p->mohinterpret);
 		break;
 	case AST_CONTROL_UNHOLD:
+		ast_rtp_reset(p->rtp);
 		ast_moh_stop(ast);
 		break;
 	case AST_CONTROL_VIDUPDATE:	/* Request a video frame update */
Index: main/rtp.c
===================================================================
--- main/rtp.c	(revision 92441)
+++ main/rtp.c	(working copy)
@@ -2615,6 +2615,8 @@
 	ms = calc_txstamp(rtp, &f->delivery);
 	/* Default prediction */
 	if (f->subclass < AST_FORMAT_MAX_AUDIO) {
+		int lastts = rtp->lastts;
+
 		pred = rtp->lastts + f->samples;
 
 		/* Re-calculate last TS */
@@ -2630,6 +2632,11 @@
 				mark = 1;
 			}
 		}
+		/* If the last timestamp was 0 let's just force the marker bit */
+		if (!lastts) {
+			ast_log(LOG_NOTICE, "forcing marker bit since timestamp is now back at 0\n");
+			mark = 1;
+		}
 	} else {
 		mark = f->subclass & 0x1;
 		pred = rtp->lastovidtimestamp + f->samples;
